export function noopLogger() {
    return {
        // tslint:disable:no-empty
        trace: () => { },
        debug: () => { },
        info: () => { },
        warn: () => { },
        error: () => { },
        fatal: () => { },
        child: () => noopLogger(),
    };
}
const levelNumber = {
    trace: 0,
    debug: 1,
    info: 2,
    warn: 3,
    error: 4,
    fatal: 5,
};
export function consoleLogger(level = 'warn', context) {
    // tslint:disable:no-console
    // tslint:disable:no-unused-expression
    return {
        trace: (...rest) => {
            levelNumber[level] <= 0 &&
                (context
                    ? console.log('TRACE', context, ...rest)
                    : console.log('TRACE', ...rest));
        },
        debug: (...rest) => {
            levelNumber[level] <= 1 &&
                (context
                    ? console.log('DEBUG', context, ...rest)
                    : console.log('DEBUG', ...rest));
        },
        info: (...rest) => {
            levelNumber[level] <= 2 &&
                (context
                    ? console.log(' INFO', context, ...rest)
                    : console.log(' INFO', ...rest));
        },
        warn: (...rest) => {
            levelNumber[level] <= 3 &&
                (context
                    ? console.log(' WARN', context, ...rest)
                    : console.log(' WARN', ...rest));
        },
        error: (...rest) => {
            levelNumber[level] <= 4 &&
                (context
                    ? console.log('ERROR', context, ...rest)
                    : console.log('ERROR', ...rest));
        },
        fatal: (...rest) => {
            levelNumber[level] <= 5 &&
                (context
                    ? console.log('FATAL', context, ...rest)
                    : console.log('FATAL', ...rest));
        },
        child: (childObj) => consoleLogger(level, context ? Object.assign({}, context, childObj) : Object.assign({}, childObj)),
    };
}
//# sourceMappingURL=index.js.map