import * as tslib_1 from "tslib";
export function noopLogger() {
    return {
        // tslint:disable:no-empty
        trace: function () { },
        debug: function () { },
        info: function () { },
        warn: function () { },
        error: function () { },
        fatal: function () { },
        child: function () { return noopLogger(); },
    };
}
var levelNumber = {
    trace: 0,
    debug: 1,
    info: 2,
    warn: 3,
    error: 4,
    fatal: 5,
};
export function consoleLogger(level, context) {
    if (level === void 0) { level = 'warn'; }
    // tslint:disable:no-console
    // tslint:disable:no-unused-expression
    return {
        trace: function () {
            var rest = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                rest[_i] = arguments[_i];
            }
            levelNumber[level] <= 0 &&
                (context
                    ? console.log.apply(console, ['TRACE', context].concat(rest)) : console.log.apply(console, ['TRACE'].concat(rest)));
        },
        debug: function () {
            var rest = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                rest[_i] = arguments[_i];
            }
            levelNumber[level] <= 1 &&
                (context
                    ? console.log.apply(console, ['DEBUG', context].concat(rest)) : console.log.apply(console, ['DEBUG'].concat(rest)));
        },
        info: function () {
            var rest = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                rest[_i] = arguments[_i];
            }
            levelNumber[level] <= 2 &&
                (context
                    ? console.log.apply(console, [' INFO', context].concat(rest)) : console.log.apply(console, [' INFO'].concat(rest)));
        },
        warn: function () {
            var rest = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                rest[_i] = arguments[_i];
            }
            levelNumber[level] <= 3 &&
                (context
                    ? console.log.apply(console, [' WARN', context].concat(rest)) : console.log.apply(console, [' WARN'].concat(rest)));
        },
        error: function () {
            var rest = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                rest[_i] = arguments[_i];
            }
            levelNumber[level] <= 4 &&
                (context
                    ? console.log.apply(console, ['ERROR', context].concat(rest)) : console.log.apply(console, ['ERROR'].concat(rest)));
        },
        fatal: function () {
            var rest = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                rest[_i] = arguments[_i];
            }
            levelNumber[level] <= 5 &&
                (context
                    ? console.log.apply(console, ['FATAL', context].concat(rest)) : console.log.apply(console, ['FATAL'].concat(rest)));
        },
        child: function (childObj) {
            return consoleLogger(level, context ? tslib_1.__assign({}, context, childObj) : tslib_1.__assign({}, childObj));
        },
    };
}
//# sourceMappingURL=index.js.map